/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20130823-64 [Aug 28 2013]
 * Copyright (c) 2000 - 2013 Intel Corporation
 * 
 * Disassembly of ssdt2.dat, Sat Sep 28 02:24:43 2013
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000032C (812)
 *     Revision         0x01
 *     Checksum         0x4A
 *     OEM ID           "Sony"
 *     OEM Table ID     "VAIO"
 *     OEM Revision     0x20120822 (538052642)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("ssdt2.aml", "SSDT", 1, "Sony", "VAIO", 0x20120822)
{
    /*
     * iASL Warning: There were 1 external control methods found during
     * disassembly, but additional ACPI tables to resolve these externals
     * were not specified. This resulting disassembler output file may not
     * compile because the disassembler did not know how many arguments
     * to assign to these methods. To specify the tables needed to resolve
     * external control method references, use the one of the following
     * example iASL invocations:
     *     iasl -e <ssdt1.aml,ssdt2.aml...> -d <dsdt.aml>
     *     iasl -e <dsdt.aml,ssdt2.aml...> -d <ssdt1.aml>
     */
    External (_SB_.PCI0.LPCB.SNC_.CHHD, MethodObj)    // Warning: Unresolved Method, guessing 1 arguments (may be incorrect, see warning above)

    External (_SB_.PCI0, DeviceObj)
    External (FDTP)
    External (GIV0)
    External (GL00)
    External (GL08)
    External (GPE3)
    External (GPS3)
    External (PFLV)

    Scope (\_SB.PCI0)
    {
        Device (AHCI)
        {
            Name (_ADR, 0x001F0002)  // _ADR: Address
            Name (FRZN, Zero)
            Method (FCHK, 2, NotSerialized)
            {
                CreateWordField (Arg0, Zero, W000)
                CreateWordField (Arg0, 0x0100, W128)
                And (FRZN, XOr (Arg1, 0xFF), FRZN)
                If (LEqual (And (W000, 0x8080), Zero))
                {
                    If (LAnd (W128, One))
                    {
                        If (LEqual (And (W128, 0x08), Zero))
                        {
                            Or (FRZN, Arg1, FRZN)
                        }
                    }
                }
            }

            Name (GTF0, Buffer (0x07)
            {
                 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5
            })
            Name (GTF1, Buffer (0x07)
            {
                 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xF5
            })
            Device (PRT0)
            {
                Name (_ADR, 0xFFFF)  // _ADR: Address
                Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
                {
                    FCHK (Arg0, One)
                    \_SB.PCI0.LPCB.SNC.CHHD (Arg0)
                }

                Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
                {
                    If (LAnd (FRZN, One))
                    {
                        Return (GTF0)
                    }
                    Else
                    {
                        Return (Buffer (Zero) {})
                    }
                }
            }

            Device (PRT1)
            {
                Name (_ADR, 0x0001FFFF)  // _ADR: Address
                Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
                {
                    FCHK (Arg0, 0x02)
                }

                Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
                {
                    If (LAnd (FRZN, 0x02))
                    {
                        Return (GTF1)
                    }
                    Else
                    {
                        Return (Buffer (Zero) {})
                    }
                }
            }

            Device (PRT2)
            {
                Name (_ADR, 0x0002FFFF)  // _ADR: Address
                Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
                {
                    FCHK (Arg0, 0x04)
                }

                Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
                {
                    If (LAnd (FRZN, 0x04))
                    {
                        Return (GTF0)
                    }
                    Else
                    {
                        Return (Buffer (Zero) {})
                    }
                }
            }

            Device (PRT3)
            {
                Name (_ADR, 0x0003FFFF)  // _ADR: Address
                Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
                {
                    FCHK (Arg0, 0x08)
                }

                Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
                {
                    If (LAnd (FRZN, 0x08))
                    {
                        Return (GTF1)
                    }
                    Else
                    {
                        Return (Buffer (Zero) {})
                    }
                }
            }

            Device (PRT4)
            {
                Name (_ADR, 0x0004FFFF)  // _ADR: Address
                Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
                {
                    FCHK (Arg0, 0x10)
                }

                Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
                {
                    If (LAnd (FRZN, 0x10))
                    {
                        Return (GTF0)
                    }
                    Else
                    {
                        Return (Buffer (Zero) {})
                    }
                }

                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Name (_T_1, Zero)  // _T_x: Emitted by ASL Compiler
                    Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                    If (LEqual (Arg0, Buffer (0x10)
                            {
                                /* 0000 */   0x30, 0xEF, 0xFA, 0xBD, 0xBB, 0xAE, 0xDE, 0x11,
                                /* 0008 */   0x8A, 0x39, 0x08, 0x00, 0x20, 0x0C, 0x9A, 0x66
                            }))
                    {
                        While (One)
                        {
                            Store (ToInteger (Arg2), _T_0)
                            If (LEqual (_T_0, Zero))
                            {
                                While (One)
                                {
                                    Store (ToInteger (Arg1), _T_1)
                                    If (LEqual (_T_1, One))
                                    {
                                        If (LEqual (PFLV, FDTP))
                                        {
                                            Return (Buffer (One)
                                            {
                                                 0x00
                                            })
                                        }

                                        Return (Buffer (One)
                                        {
                                             0x0F
                                        })
                                    }
                                    Else
                                    {
                                        Return (Buffer (One)
                                        {
                                             0x00
                                        })
                                    }

                                    Break
                                }
                            }
                            Else
                            {
                                If (LEqual (_T_0, One))
                                {
                                    Return (One)
                                }
                                Else
                                {
                                    If (LEqual (_T_0, 0x02))
                                    {
                                        Store (Zero, GPE3)
                                        If (LEqual (And (GL00, 0x08), 0x08))
                                        {
                                            Or (GIV0, 0x08, GIV0)
                                        }
                                        Else
                                        {
                                            And (GIV0, 0xF7, GIV0)
                                        }

                                        And (GL08, 0xEF, GL08)
                                        Sleep (0xC8)
                                        Store (One, GPS3)
                                        Store (One, GPE3)
                                        Return (One)
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_0, 0x03))
                                        {
                                            Store (Zero, GPE3)
                                            Store (One, GPS3)
                                            Or (GL08, 0x10, GL08)
                                            Return (One)
                                        }
                                        Else
                                        {
                                            Return (Zero)
                                        }
                                    }
                                }
                            }

                            Break
                        }
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }
            }

            Device (PRT5)
            {
                Name (_ADR, 0x0005FFFF)  // _ADR: Address
                Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
                {
                    FCHK (Arg0, 0x20)
                }

                Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
                {
                    If (LAnd (FRZN, 0x20))
                    {
                        Return (GTF1)
                    }
                    Else
                    {
                        Return (Buffer (Zero) {})
                    }
                }
            }
        }
    }
}

